barang/urls.py
from django.urls import path
from .views import barang_view, semua_barang_view, barang_view_buy, barang_view_review

app_name = 'barang'

urlpatterns = [
    path('<int:id>/buy', barang_view_buy, name='barang-buy'),
    path('<int:id>/review', barang_view_review, name='barang-review'),
    path('<int:id>', barang_view, name='barang-detail'),
    path('all/<str:filter>', semua_barang_view, name='barang-filter'),
    path('all', semua_barang_view, name='barang-all')
]

kategori/urls.py
from django.urls import path
from .views import kategori_view

app_name = 'kategori'

urlpatterns = [
    path('<str:kategori>', kategori_view, name='kategori'),
    path('', kategori_view, name='kategori-default')
]

keranjang/urls.py
from django.urls import path
from .views import keranjang_view, keranjang_add_view, keranjang_update_jumlah_view, keranjang_hapus_view

app_name = 'keranjang'

urlpatterns = [
    path('', keranjang_view, name='keranjang'),
    path('add', keranjang_add_view, name='add'),
    path('update-jumlah', keranjang_update_jumlah_view, name='update-jumlah'),
    path('hapus', keranjang_hapus_view, name='hapus')
]

kupon/urls.py
from django.urls import path
from .views import semua_kupon_view, kupon_api_view

app_name = 'kupon'

urlpatterns = [
    path('', semua_kupon_view, name='semua-kupon'),
    path('api/semua', kupon_api_view, name='kupon-api')
]

onlineshop/urls.py
from django.contrib import admin
from django.urls import path, include
from register import views as regviews

urlpatterns = [
    path('admin/', admin.site.urls),
    path('accounts/', include('django.contrib.auth.urls')),
    path('barang/', include('barang.urls')),
    path('kategori/', include('kategori.urls')),
    path('kupon/', include('kupon.urls')),
    path('transaksi/', include('transaksi.urls')),
    path('ulasan/', include('ulasan.urls')),
    path('shopadmin/', include('shopadmin.urls')),
    path('', include('landing.urls')),
    path('register/', include('register.urls', namespace='register')),
    path('keranjang/', include('keranjang.urls')),
    path('', include('django.contrib.auth.urls')),
    path('', include('social_django.urls', namespace='social')),
    # path('login/', regviews.login, name='login'),
]

ulasan/urls.py
from django.urls import path
from .views import semua_ulasan_view, add_ulasan_view, delete_ulasan_view

app_name = 'ulasan'

urlpatterns = [
    path('', semua_ulasan_view, name='all-ulasan'),
    path('api/add', add_ulasan_view, name='add'),
    path('api/delete', delete_ulasan_view, name='delete')
]

templates/includes/leftcontent.html
<div id="sidebar" class="mx-5 mt-2 px-4 py-2">
  <ul class="nav flex-column">
    <li class="nav-item">
      <a href="{% url 'barang:barang-all' %}" class="nav-link sidelink"
        >Products</a
      >
    </li>
    <li class="nav-item">
      <a href="{% url 'ulasan:all-ulasan' %}" class="nav-link sidelink"
        >Reviews</a
      >
    </li>
    <li class="nav-item">
      <a href="{% url 'kupon:semua-kupon' %}" class="nav-link sidelink"
        >Coupons</a
      >
    </li>
    <li class="nav-item">
      <a href="{% url 'transaksi:all-transactions' %}" class="nav-link sidelink"
        >Orders</a
      >
    </li>
    <li class="nav-item">
      <a href="{% url 'kategori:kategori-default' %}" class="nav-link sidelink"
        >Categories</a
      >
    </li>
    <li class="nav-item">
      <a href="{% url 'transaksi:riwayat-cepat' %}" class="nav-link sidelink"
        >Riwayat Cepat</a
      >
    </li>
    <li class="nav-item">
      <a href="{% url 'keranjang:keranjang' %}" class="nav-link sidelink"
        >Keranjang</a
      >
    </li>
    {% if user.is_staff %}
    <li class="nav-item">
      <a href="{% url 'shopadmin:shop-admin' %}" class="nav-link sidelink"
        >Admin</a
      >
    </li>
    {% endif %}
  </ul>
</div>

templates/includes/navbar.html
{% load static %}
<nav
  class="navbar navbar-expand-lg navbar-light bg-transparent d-flex justify-content-between px-1 mx-4"
>
  <button
    class="navbar-toggler"
    type="button"
    data-toggle="collapse"
    data-target="#navbartoggle"
    aria-controls="navbartoggle"
    aria-expanded="false"
    aria-label="Toggle navigation"
  >
    <span class="navbar-toggler-icon"></span>
  </button>
  <a class="navbar-brand" href="/"
    ><img src="{% static 'logo.svg' %}" class="logo"
  /></a>
  <form
    class="form-inline my-2 my-lg-0 d-none d-lg-block"
    action="{% url 'barang:barang-all'%}"
  >
    <div class="position-relative">
      <input
        class="form-control mr-sm-2 searchbar vw-25"
        type="search"
        name="filter"
        placeholder="Search for items, brands"
        aria-label="Search"
      />
      <div class="d-flex align-items-center" id="search-icon">
        <svg
          width="32"
          height="32"
          viewBox="0 0 32 32"
          fill="none"
          xmlns="http://www.w3.org/2000/svg"
        >
          <path
            d="M20.6667 18.6667H19.6133L19.24 18.3067C20.5467 16.7867 21.3333 14.8133 21.3333 12.6667C21.3333 7.88 17.4533 4 12.6667 4C7.88 4 4 7.88 4 12.6667C4 17.4533 7.88 21.3333 12.6667 21.3333C14.8133 21.3333 16.7867 20.5467 18.3067 19.24L18.6667 19.6133V20.6667L25.3333 27.32L27.32 25.3333L20.6667 18.6667ZM12.6667 18.6667C9.34667 18.6667 6.66667 15.9867 6.66667 12.6667C6.66667 9.34667 9.34667 6.66667 12.6667 6.66667C15.9867 6.66667 18.6667 9.34667 18.6667 12.6667C18.6667 15.9867 15.9867 18.6667 12.6667 18.6667Z"
            fill="#222222"
          />
        </svg>
      </div>
    </div>
  </form>
  <div class="px-2 pr-1 d-none d-lg-flex justify-content-center">
    {% if user.is_authenticated %}
    <div class="mx-2 user-text d-flex align-items-center">
      {{user.username}}
    </div>
    {% else %}
    <div class="mx-2 user-text d-flex align-items-center">Not Logged In</div>
    {% endif %}
    <div class="nav-item dropdown d-flex align-items-center">
      <img src="{% static 'avatar.svg' %}" class="avatar" />
      <a
        class="nav-link dropdown-toggle"
        href="#"
        id="navbarDropdownMenuLink"
        role="button"
        data-toggle="dropdown"
        aria-haspopup="true"
        aria-expanded="false"
      >
      </a>
      <div class="dropdown-menu" aria-labelledby="navbarDropdownMenuLink">
        {% if user.is_authenticated %}
        {% if request.user.is_staff %}
        <a class="dropdown-item" href="{% url 'shopadmin:shop-admin' %}"
          >Admin</a
        >
        {% endif %}
        <a class="dropdown-item" href="{% url 'keranjang:keranjang' %}">Keranjang</a> 
        <a class="dropdown-item" href="{% url 'logout' %}">Logout</a>
        {% else %}
        <a class="dropdown-item" name="register" href="{% url 'register:register' %}">Register</a>
        <a class="dropdown-item" name="login" href="{% url 'login' %}">Login</a>
        {% endif %}
      </div>
    </div>
  </div>

  <div class="collapse" id="navbartoggle">
    <nav class="nav flex-column">
      <a class="nav-link" href="/">Home</a>
      <a class="nav-link" href="{% url 'kategori:kategori-default' %}"
        >Categories</a
      >
      <a class="nav-link" href="{% url 'barang:barang-all' %}">Products</a>
      <a class="nav-link" href="#">Coupons</a>
    </nav>
  </div>
</nav>

templates/includes/recommended.html
<div id="recommended-column">
  <h3 class="mb-3">Recommended</h3>
  <div class="d-flex flex-column">
    <div class="recommended-card">
      <a href="{% url 'barang:barang-detail' id=1 %}">
        <div class="product-card">
          <img
            src="https://media.swansonvitamins.com/images/items/master/SW1371.jpg"
            class="image-recommended"
          />
          <div class="item-description w-100 px-3">
            <span class="text-muted">37 pcs</span>
            <h4>Vitamin C</h4>
          </div>
        </div>
      </a>
    </div>
    <div class="recommended-card">
      <a href="{% url 'barang:barang-detail' id=2 %}">
        <div class="product-card">
          <img
            src="https://media.swansonvitamins.com/images/items/master/SW1371.jpg"
            class="image-recommended"
          />
          <div class="item-description w-100 px-3">
            <span class="text-muted">36 pcs</span>
            <h4>Vitamin D</h4>
          </div>
        </div>
      </a>
    </div>
  </div>
</div>